module Golden where

import Test.Tasty

import qualified Golden.Grammar
import qualified Golden.Machine
import qualified Golden.Parser
import qualified Golden.Splice

goldens :: TestTree
goldens = testGroup "Golden"
  [ Golden.Grammar.goldens
  , Golden.Machine.goldens
  , Golden.Parser.goldens
  , Golden.Splice.goldens
  ]
